//
// WtFrame
//
//
// Copyright  2005, glenn andreas, all rights reserved
//


// view flag constants
var vNoFlags		= 0x00000000;
var vVisible		= 0x00000001;
var vReadOnly		= 0x00000002;
var vApplication		= 0x00000004;
var vKeyable		= vApplication; // same thing
var vCalculateBounds	= 0x00000008;
var vClipping		= 0x00000020;
var vFloating		= 0x00000040;
var vWriteProtected		= 0x00000080;
var vClickable		= 0x00000200;
var vNoScripts		= 0x08000000;
// add'n
var vSelected		= 0x00000100;
var vDisabled		= 0x00000400;

// some of the viewJustify values
var vjLeftH			= 0x00000000;
var vjCenterH		= 0x00000002;
var vjRightH		= 0x00000001;
var vjFullH			= 0x00000003;
var vjTopV			= 0x00000000;
var vjCenterV		= 0x00000004;
var vjBottomV		= 0x00000008;
var vjFullV			= 0x0000000C;
var vjParentLeftH	= 0x00000000;
var vjParentCenterH		= 0x00000010;
var vjParentRightH	= 0x00000020;
var vjParentFullH	= 0x00000030;
var vjSiblingNoH		= 0x00000000;
var vjSiblingLeftH	= 0x00000800;
var vjSiblingCenterH	= 0x00000200;
var vjSiblingRightH		= 0x00000400;
var vjSiblingFullH	= 0x00000600;
var vjParentTopV		= 0x00000000;
var vjParentCenterV		= 0x00000040;
var vjParentBottomV		= 0x00000080;
var vjParentFullV	= 0x000000C0;
var vjSiblingNoV		= 0x00000000;
var vjSiblingTopV	= 0x00004000;
var vjSiblingCenterV	= 0x00001000;
var vjSiblingBottomV	= 0x00002000;
var vjSiblingFullV	= 0x00003000;
var vjNoRatio		= 0x00000000;
var vjLeftRatio			= 0x04000000;
var vjRightRatio		= 0x08000000;
var vjTopRatio		= 0x10000000;
var vjBottomRatio	= 0xe0000000;
var vjParentAnchored	= 0x00000100;
// add'n
var vjFlexWidth		= 0x00100000;
var vjFlexHeight		= 0x00200000;

// a variation of proto that adds the implicit heirarchy, notifications
var wt_Private = {
	wt_TopLevelObjects : {},
	wt_Root : null,
	wt_Application : null,
	wt_KeyView : null,
	wt_DirtyViews : null,
	wt_DirtyInterval : null,
	RefreshViews : function()
	{
		var toRefresh = wt_Private.wt_DirtyViews;
		wt_Private.wt_DirtyViews = null; // and clear the list
		wt_Private.wt_DirtyInterval = null; // and the interval (which has expired)
		if (!toRefresh || toRefresh.length == 0) {
			return; // nothing to do
		}
		for (var i=0;i<toRefresh.length;i++) {
			if (Visible(toRefresh[i])) {
				toRefresh[i].RefreshView();
			}
		}
	},
	NeedToRefreshView : function(view)
	{
		if (wt_Private.wt_DirtyViews) {
			// already have one waiting
			for (var i=0;i<wt_Private.wt_DirtyViews.length;i++) {
				if (wt_Private.wt_DirtyViews[i] == view) {
					return; // alread in the list
				}
			}
			wt_Private.wt_DirtyViews.push(view);
		} else {
			wt_Private.wt_DirtyViews = [view];
			wt_Private.wt_DirtyInterval = setTimeout(wt_Private.RefreshViews, 5); // redraw in a bit
		}
	}

};

function GetView(vid)
{
	if (typeof vid == typeof "") {
		if (vid == 'viewFrontMost') {
		} else if (vid == 'viewFrontMostApp') {
			return wt_Private.wt_Application;
		} else if (vid == 'viewFrontKey') {
			return wt_Private.wt_KeyView;
		} else {
			if (vid.slice(0,1) == '.') {
				var parts = vid.split('.');
				var retval = wt_Private.wt_TopLevelObjects[parts[0]];
				for (var i=1;i<parts.length;i++) {
					retval = retval.children[parts[i]]; // walk down the tree
				}
				return retval;
			} else {
				return GetRoot().GetView(vid)
			}
		}
	} else {
		return vid;
	}
}

function SetKeyView(view)
{
	if (view === wt_Private.wt_KeyView) { // already set
		return;
	}
	if (wt_Private.wt_KeyView) {
		wt_Private.wt_KeyView.Hilite(false);
	}
	wt_Private.wt_KeyView = view;
	if (view) {
		view.Hilite(true);
	}
}

function GetRoot()
{
	return wt_Private.wt_Root;
}

function DeclareStepChild(child, parent, name)
{
	if (!HasSlot(parent, 'stepAllocateContext')) {
		// we don't have one, but our proto might
		if (parent.stepAllocateContext) {
			parent.stepAllocateContext = Clone(parent.stepAllocateContext);
		} else {
			parent.stepAllocateContext = [];
		}
	}
	if (name) {
		parent[name] = {}; // create an empty object to have temporary values
	}
	child.preallocatedContext = name;
	for (var i=0;i<parent.stepAllocateContext.length;i+=2) {
		if (parent.stepAllocateContext[i] == name) { // already exists, replace it
			parent.stepAllocateContext[i+1] = child;
			return parent[name];
		}
	}
	parent.stepAllocateContext.push(name);
	parent.stepAllocateContext.push(child);
	if (name) {
		return parent[name];
	} else {
		return null;
	}
}
function DeclareChild(child, parent, name)
{
	if (!HasSlot(parent, 'viewAllocateContext')) {
		// we don't have one, but our proto might
		if (parent.viewAllocateContext) {
			parent.viewAllocateContext = Clone(parent.viewAllocateContext);
		} else {
			parent.viewAllocateContext = [];
		}
	}
	parent[name] = {};
	child.preallocatedContext = name;
	for (var i=0;i<parent.viewAllocateContext.length;i+=2) {
		if (parent.viewAllocateContext[i] == name) { // already exists, replace it
			parent.viewAllocateContext[i+1] = child;
			return parent[name];
		}
	}
	parent.viewAllocateContext.push(name);
	parent.viewAllocateContext.push(child);
	return parent[name];
}

function SetValue(view, slotSymbol, value)
{
	if (typeof view == "string") {
		view = GetView(view);
	}
	if (view) {
		view[slotSymbol] = value;
		var parent = view;
		while (parent && parent.ViewChangedScript == null) {
			parent = view._parent; // go up through parents to find ViewChangedScript that cares
		}
		if (parent.ViewChangedScript) {
			parent.ViewChangedScript(slotSymbol, value);
		}
		parent = view;
		while (parent) { // go through and notify based on proto
			if (HasSlot(parent,'tiedViews')) {
				for (var i=0;i<view.tiedViews.length;i+=1) {
					view.tiedViews[i].dependantView[view.tiedViews[i].methodName](view, slotSymbol);
				}
			}
			parent = parent._proto;
		}
		view.Dirty(); // mark as dirty (not that this should do anything in most case)
	}
}

function TieViews(mainView, dependantView, methodName)
{
	if (!HasSlot(mainView, 'tiedViews')) {
		// make sure we don't do inheritence here
		mainView.tiedViews = [];
	}
	mainView.tiedViews.push({dependantView : depentandView, methodName : methodName});
}

function RefreshViews()
{
	// if we call it explicitly, this will clear the timeout
	if (wt_Private.wt_DirtyInterval) { // and if we don't have a timeout, we don't have dirty views
		clearTimeout(wt_Private.wt_DirtyInterval);
		wt_Private.wt_DirtyInterval = null;
		wt_Private.RefreshViews();
	}
}


function Visible(view) {
	if (typeof view == "string") {
		view = GetView(view);
	}
	if (!view) return false;
	// need to check latent invisible
	while (view && (view.viewFlags & vVisible) != 0) {
		view = view._proto;
	}
	if (view) {
		// we've found a view not visibile
		return false;
	} else {
		// we went to root, visible all the way
		return true;
	}
}
function AddStepView(parentView, childTemplate)
{
	if (typeof parentView == 'string') {
		parentView = GetView(parentView);
	}
	parentView.AddStepView(childTemplate);
}
function RemoveStepView(parentView, childTemplate)
{
	if (typeof parentView == 'string') {
		parentView = GetView(parentView);
	}
	parentView.RemoveStepView(childTemplate);
}

function RelBounds(left, top, width, height)
{
	return {
		'left' : left,
		'top' : top,
		'right' : left + width,
		'bottom' : top + height
	};
}

function SetBounds(left, top, right, bottom)
{
	return {
		'left' : left,
		'top' : top,
		'right' : right,
		'bottom' : bottom
	};
}

function nullfunc() {}

protoView = Proto({
	/// widget specific events
	WidgetShowScript : function() {
		// make sure to update our idle timer
		this.ResumeIdle();
	},
	WidgetHideScript : function() {
		// make sure to update our idle timer
		this.SuspendIdle();
	},
	WidgetFocusScript : nullfunc,
	WidgetBlurScript : nullfunc,
	WidgetStartupScript : nullfunc,
	WidgetRemoveScript : nullfunc,
	ViewParentPointedScript : nullfunc, // when mouse move over widget - takes two params, the parent and the event
	ViewParentUnpointedScript : nullfunc,
	// view events
	/// Application Defined Methods
	ViewSetupFormScript : nullfunc,
	//ViewSetupChildrenScript : nullfunc,
	ViewSetupChildrenScript : function() {
		// install all the various callbacks
		var self = this;
		this.viewElement.onmouseover = function f(event) { self.CallChildrenScripts2('ViewParentPointedScript', self, event); };
		this.viewElement.onmouseout = function f(event) { self.CallChildrenScripts2('ViewParentUnpointedScript', self, event); };
		this.viewElement.onmousedown = function f(event) {
			var target = self;
			while (target && !(target.viewFlags & vClickable)) {
				target = target._parent;
			}
			if (target) {
				return target.ViewClickScript(event);
			}
			return true;
		}
	},
	ViewSetupDoneScript : nullfunc,
	ViewQuitScript : nullfunc,
	ViewPostQuitScript : nullfunc,
	ViewShowScript : nullfunc,
	ViewHideScript : nullfunc,
	// ViewDrawScript : nullfunc, // things draw by themselves
	ViewHiliteScript : nullfunc,
	// Reorient?  Resize
	ViewScrollDownScript : nullfunc,
	ViewScrollUpScript : nullfunc,
	// ViewOverviewScript : nullfunc // no overview button
	ViewAddChildScript : nullfunc,
	ViewChangedScript : null, //func,
	ViewDropChildScript : nullfunc,
	ViewIdleScript : nullfunc,
	ViewClickScript : nullfunc,
	// drag & drop handled differently
	// various other scripts
	ButtonPressedScript : nullfunc,
	ViewDragScript : nullfunc, // called repeated while tracking, so you can drag, or draw or whatever
	// flags, etc...
	viewFlags : vVisible,
	currentViewAnimation : null,
	elementClass : 'div', // what we create, by default a div
	viewClass : 'view',
	_init : function() {
		// these values are in the derived things
		this._parent = null;
		this.stepChildren = [];
		this.viewChildren = [];
		this.__orderedChildren = [];
		// we might inherit the context - want a copy of them
		if (this._proto && this._proto.stepAllocateContext) {
			this.stepAllocateContext = Clone(this.stepAllocateContext);
		} else {
			this.stepAllocateContext = [];
		}
		if (this._proto && this._proto.viewAllocateContext) {
			this.viewAllocateContext = Clone(this.viewAllocateContext);
		} else {
			this.viewAllocateContext = [];
		}
		if (this.declareSelf) { // link up declareSelf
			this[this.declareSelf] = this;
		}
	},
	ancestor : function() {
		if (this._parent) {
			return this._parent.ancestor();
		}
		return this;
	},
	ChildViewFrames : function() {
		return this.__orderedChildren;
	},
	Parent : function() {
		return this._parent;
	},
	GetView : function(symbol) {
		if (symbol == this.viewElementId) {
			return this;
		}
		var children = this.ChildViewFrames();
		for (var i=0;i<children.length;i++) {
			var retval = children[i].GetView(symbol);
			if (retval) {
				return retval;
			}
		}
		return null;
	},
	CreateElement : function() {
		// by default, we are a div
		return document.createElement(this.elementClass);
	},
	CallChildrenScripts : function(script) {
		for (var i=0;i<this.__orderedChildren.length;i+=1) {
			this.__orderedChildren[i].CallChildrenScripts(script);
		}
		if (this[script]) {
			this[script]();
		}
	},
	CallChildrenScripts1 : function(script, param1) {
		for (var i=0;i<this.__orderedChildren.length;i+=1) {
			this.__orderedChildren[i].CallChildrenScripts1(script, param1);
		}
		if (this[script]) {
			this[script](param1);
		}
	},
	CallChildrenScripts2 : function(script, param1, param2) {
		for (var i=0;i<this.__orderedChildren.length;i+=1) {
			this.__orderedChildren[i].CallChildrenScripts2(script, param1, param2);
		}
		if (this[script]) {
			this[script](param1, param2);
		}
	},
	GlobalBox : function() {
		var left = this.viewElement.offsetLeft;
		var top = this.viewElement.offsetTop;
		var par = this.viewElement.offsetParent;
		while (par) {
			left += par.offsetLeft;
			top += par.offsetTop;
			par = par.offsetParent;
		}
		return RelBounds(left, top, this.viewElement.offsetWidth, this.viewElement.offsetHeight);
	},
	CalcJustify : function() {
		var sibling = null; // no sibling
		var siblingList = this._parent.ChildViewFrames();
		if (siblingList && siblingList.length) {
			sibling = siblingList[siblingList.length-1].viewElement; // get the default value if we aren't added yet
			// but check to see if we are in the list
			for (i=1;i<siblingList.length;i++) {
				if (siblingList[i] == this) {
					sibling = siblingList[i-1].viewElement;
					break;
				}
			}
		}
		var parentWidth = 0;
		var parentHeight = 0;
		if (this.viewElement.offsetParent) {
			parentHeight = this.viewElement.offsetParent.offsetHeight;
			parentWidth = this.viewElement.offsetParent.offsetWidth;
		}
		var siblingLeft;
		var siblingTop;
		var siblingRight;
		var siblingBottom;
		if (sibling) {
			// in parent coordinates
			siblingLeft = sibling.offsetLeft;
			siblingTop = sibling.offsetTop;
			siblingRight = sibling.offsetLeft + sibling.offsetWidth;
			siblingBottom = sibling.offsetTop + sibling.offsetHeight;
		} else {
			// parent, in parent coordinates
			siblingLeft = 0;
			siblingTop = 0;
			siblingRight = parentWidth;
			siblingBottom = parentHeight;
		}
		if (!this.viewJustify) { this.viewJustify = 0; } // make sure it's an int
		var vb = this.viewBounds;
		var retval = { left : null, top: null, right: null, bottom: null, width: null, height: null };
		// do it horizontally
		if ((this.viewJustify & (vjParentFullH)) == vjParentFullH) {
			// full justify from parent
			retval.left = vb.left;
			retval.right = vb.right;
		} else if ((this.viewJustify & (vjParentCenterH)) == vjParentCenterH) {
			if (this.viewJustify & vjFlexWidth) {
				retval.left = (parentWidth - (vb.right - vb.left)) / 2;
				retval.right = (parentWidth + (vb.right - vb.left)) / 2;
			} else {
				retval.width = (vb.right - vb.left);
				retval.left = (parentWidth - (vb.right - vb.left)) / 2 + vb.left;
			}
		} else if ((this.viewJustify & (vjParentRightH)) == vjParentRightH) {
			retval.width = (vb.left - vb.right); // since left > right
			if (retval.width < 0) {
				retval.width = -retval.width;
			}
			//retval.left = parentWidth - retval.width + retval.right;
			retval.right = -vb.right;
		} else if ((this.viewJustify & (vjSiblingLeftH)) == vjSiblingLeftH) {
			retval.width = (vb.right - vb.left);
			retval.left = siblingLeft + vb.left;
		} else if ((this.viewJustify & (vjSiblingFullH)) == vjSiblingFullH) {
			retval.left = siblingLeft + vb.left;
			retval.right = (parentWidth - siblingRight) + vb.right;
		} else if ((this.viewJustify & (vjSiblingCenterH)) == vjSiblingCenterH) {
			retval.width = (vb.right - vb.left);
			retval.left = ((siblingLeft + siblingRight) - (vb.right - vb.left)) / 2;
		} else if ((this.viewJustify & (vjSiblingRightH)) == vjSiblingRightH) {
			retval.width = (vb.right - vb.left);
			retval.right = parentWidth - (siblingRight + vb.left + (vb.right - vb.left));
		} else {
			// default, left justfiy, fixed width
			retval.width = (vb.right - vb.left);
			retval.left = vb.left;
		}
		// now vertically
		if ((this.viewJustify & (vjParentFullV)) == vjParentFullV) {
			// full justify from parent
			retval.top = vb.top;
			retval.bottom = vb.bottom;
		} else if ((this.viewJustify & (vjParentCenterV)) == vjParentCenterV) {
			if (this.viewJustify & vjFlexHeight) {
				retval.bottom = (parentHeight + (vb.bottom - vb.top)) / 2;
				retval.top = (parentHeight - (vb.bottom - vb.top)) / 2;
			} else {
				retval.height = (vb.bottom - vb.top);
				retval.top = (parentHeight - (vb.bottom - vb.top)) / 2 + vb.top;
			}
		} else if ((this.viewJustify & (vjParentBottomV)) == vjParentBottomV) {
			retval.height = (vb.top - vb.bottom); // since top > bottom here
			if (retval.height < 0) {
				retval.height = -retval.height;
			}
			retval.bottom = (-vb.bottom);
		} else if ((this.viewJustify & (vjSiblingTopV)) == vjSiblingTopV) {
			retval.height = (vb.bottom - vb.top);
			retval.top = siblingTop + vb.top;
		} else if ((this.viewJustify & (vjSiblingFullV)) == vjSiblingFullV) {
			retval.top = siblingTop + vb.top;
			retval.bottom = (parentHeight - siblingBottom) + vb.bottom;
		} else if ((this.viewJustify & (vjSiblingCenterV)) == vjSiblingCenterV) {
			retval.height = (vb.bottom - vb.top);
			retval.top = ((siblingTop + siblingBottom) - (vb.bottom - vb.top)) / 2;
		} else if ((this.viewJustify & (vjSiblingBottomV)) == vjSiblingBottomV) {
			retval.height = (vb.bottom - vb.top);
			retval.bottom = parentHeight - (siblingBottom + (vb.bottom - vb.top) + vb.top);
		} else {
			// default, top justfiy, fixed height
			retval.height = (vb.bottom - vb.top);
			retval.top = vb.top;
		}
		if (this.viewElement.offsetParent) {
			// hidden object aren't adjusted
			if (retval.left === null && retval.width !== null && retval.right !== null) {
				retval.left = parentWidth - retval.width - retval.right;
			}
			if (retval.width === null && retval.left !== null && retval.right !== null) {
				retval.width = parentWidth - retval.left - retval.right;
			}
			if (retval.top === null && retval.height !== null && retval.bottom !== null) {
				retval.top = parentHeight - retval.height - retval.bottom;
			}
			if (retval.height === null && retval.top !== null && retval.bottom !== null) {
				retval.height = parentHeight - retval.top - retval.bottom;
			}
		}
		this.PrimSetViewLocation(retval);
	},
	PrimSetViewLocation : function(bounds) {
		// for various width/height things like images or canvas
		this.viewElement.setAttribute('width', bounds.width);
		this.viewElement.setAttribute('height', bounds.height);
		if (bounds.left !== null && bounds.width !== null) {
			this.viewElement.style.left = bounds.left;
			this.viewElement.style.right = null;
			this.viewElement.style.width = bounds.width;
		}
		if (bounds.top !== null && bounds.height !== null) {
			this.viewElement.style.top = bounds.top;
			this.viewElement.style.bottom = null;
			this.viewElement.style.height = bounds.height;
		}
	},
	Open : function() {
		if ((this.viewFlags & vVisible) && this.showsound && window.Sound) { Sound.play(this.showsound);}
		// allocate the declared to stuff
		// (not needed because we use real things and not templates)
		var i, tempview;
		for (i=0;i<this.stepAllocateContext.length;i+=2) {
			if (this.stepAllocateContext[i]) {
				tempview = View({
					_proto: this.stepAllocateContext[i+1],
					//_parent: this,
					// set view elements that don't have an explicit id
					viewElementId : this.stepAllocateContext[i+1].viewElementId || this.stepAllocateContext[i]
				});
				tempview._parent = this;
				this[this.stepAllocateContext[i]] = tempview;
			} else {
				// allow anonymous step children
				tempview = View({
					//_parent: this,
					_proto: this.stepAllocateContext[i+1]
				});
				tempview._parent = this;
				this.stepChildren.push(tempview);
			}
			//this[this.stepAllocateContext[i]] = this.stepAllocateContext[i+1];
		}
		for (i=0;i<this.viewAllocateContext.length;i+=2) {
			tempview = View({
				//_parent: this,
				_proto: this.viewAllocateContext[i+1]
			});
			//this[this.viewAllocateContext[i]] = this.viewAllocateContext[i+1];
			tempview._parent = this;
			this[this.viewAllocateContext[i]] = tempview;
		}
		this.ViewSetupFormScript();
		// find out if we already exist
		if (this.viewElement == null) {
			var parElement = null;
			if (this._parent) {
				parElement = this._parent.viewElement;
			}
			if (this.viewElementId) {
				if (parElement && ! this.viewElement) {
					this.viewElement = parElement.children[this.viewElementId]; // see if there is one
				}
			}
			if (!this.viewElement) {
				//alert('Creating element ' + this.viewClass);
				this.viewElement = this.CreateElement();
				if (parElement) {
					parElement.appendChild(this.viewElement);
				} else {
					document.firstChild.appendChild(this.viewElement);
				}
			}
		}
		if (this.viewElement) {
			// set the element style based on all the heirarchy of the element, plus whatever
			// was explicitly set
			var allStyleList = []
			if (this.viewElement['class']) {
				allStyleList.push(this.viewElement['class']);
			}
			var lastStyle = this.viewClass;
			allStyleList.push(lastStyle);
			var p = this;
			while (p) {
				// walk up, gathering viewClass names as we go
				if (p.viewClass != lastStyle) { // got further up pass anonymous protos
					lastStyle = p.viewClass;
					allStyleList.push(lastStyle);
				}
				p = p._proto;
			}
			// and add in chrome style
			if (this.chromeStyle) {
				allStyleList.push(this.chromeStyle);
			}
			this.viewElement.setAttribute('class', allStyleList.join(' '));
			// now append any explicit single elements
			if (this.viewStyle) {
				// copy over any explicit view styles
				for (i in this.viewStyle) {
					this.viewElement.style[i] = this.viewStyle[i];
				}
			}
			if (this.viewJustify) {
				switch (this.viewJustify & vjFullH) {
					case vjRightH : {
						this.viewElement.style.textAlign = 'right';
						break;
					}
					case vjCenterH : {
						this.viewElement.style.textAlign = 'center';
						break;
					}
					case vjFullH: {
						this.viewElement.style.textAlign = 'justify';
						break;
					}
				}
			}
			if (this.preallocateContext) {
				this.viewElement.id = this.preallocateContext;
			} else if (this.viewElementId) {
				this.viewElement.id = this.viewElementId;
			}
			if (this.helpTag) {
				this.viewElement.title = this.helpTag;
			}
		}
		// examine viewBounds
		if (this.viewBounds) {
			this.viewElement.style.position = 'absolute';
			try {
				this.CalcJustify();
			} catch (exception) {
				alert("CalcJustify " + exception);
			}
		}
		if (this.viewElement == document.body) { // got the root
			wt_Private.wt_Root = this;
		}
		if (this.viewFlags & vApplication && wt_Private.wt_Application === null) { // got the (first) app
			wt_Private.wt_Application = this;
		}
		// add the named children
		for (var i=0;i<this.stepAllocateContext.length;i+=2) {
			this.stepChildren.push(this[this.stepAllocateContext[i]]);
		}
		for (var i=0;i<this.viewAllocateContext.length;i+=2) {
			this.viewChildren.push(this[this.viewAllocateContext[i]]);
		}
		this.ViewSetupChildrenScript();
		for (i=0;i<this.viewChildren.length;i+=1) {
			this.viewChildren[i]._parent = this;
			this.viewChildren[i].Open();
			this.__orderedChildren.push(this.viewChildren[i]);
		}
		for (i=0;i<this.stepChildren.length;i+=1) {
			this.stepChildren[i]._parent = this;
			this.stepChildren[i].Open();
			this.__orderedChildren.push(this.stepChildren[i]);
		}
		//this.CallChildrenScripts('ViewSetupDoneScript');
		// we don't call the children's ViewSetupDoneScript, since that was called when they were openned
		this.ViewSetupDoneScript();
		if (this.viewFlags & vVisible) {
			this.PrimShow();
			this.Dirty(); // everything is dirty from here on down
			this.ViewShowScript();
		} else {
			this.PrimHide();
		}
		//this.ViewDrawScript();
	},
	Close : function() {
		var viewParent = this.viewElement.offsetParent;
		this.Hide();
		var postQuit = this.ViewQuitScript();
		if (viewParent) {
			viewParent.removeChild(this.viewElement);
		}
		this.viewElement = null;
		this.__orderedChildren = []; // get rid of children
		if (postQuit == 'postQuit') {
			this.ViewPostQuitScript();
		}
	},
	Toggle : function() {
		if (this.viewElement) {
			this.Close();
		} else {
			this.Open();
		}
	},
	PrimShow : function() {
		if (this.viewElement) {
			this.viewElement.style.display = 'block';
		}
	},
	Show : function() {
		if (this.showsound && window.Sound) { Sound.play(this.showsound); }
		this.PrimShow();
		this.ViewShowScript();
		this.vFlags |= vVisible;
		// mark as needing redraw, if possible, as well as children
		this.CallChildrenScripts('Dirty');
	},
	PrimHide : function() {
		if (this.viewElement) {
			this.viewElement.style.display = 'none';
		}
	},
	Hide : function() {
		if (this.hidesound && window.Sound) { Sound.play(this.hidesound); }
		// turn off keyboard focus for our children (if any of our children or us is the key focus)
		var focus = GetView('viewFrontKey');
		while (focus) {
			if (focus == this) {
				SetKeyView(null);
				break;
			}
			focus = focus._parent;
		}
		this.PrimHide();
		this.ViewHideScript();
		this.vFlags &= ~vVisible;
	},
	OffsetView : function(dx, dy) {
		if (this.viewElement.style.left) {
			this.viewElement.style.left = dx + parseInt(this.viewElement.style.left) + "px";
		}
		if (this.viewElement.style.right) {
			this.viewElement.style.right = -dx + parseInt(this.viewElement.style.right) + "px";
		}
		if (this.viewElement.style.top) {
			this.viewElement.style.top = dy + parseInt(this.viewElement.style.top) + "px";
		}
		if (this.viewElement.style.bottom) {
			this.viewElement.style.bottom = -dy + parseInt(this.viewElement.style.bottom) + "px";
		}
	},
	LayoutTable : function(tableDef, colStart, rowStart) {
		var retval = [];
		var curIndex = tableDef.tabAcross * rowStart + colStart;
		var top = 0;
		if (tableDef.tabOriginY) {
			top = tableDef.tabOriginY;
		}
		var left = 0;
		if (tableDef.tabOriginX) {
			left = tableDef.tabOriginX;
		}
		for (var row = 0; row < tableDef.tabDown; row+=1) {
			if (tableDef.tabOriginX) {
				left = tableDef.tabOriginX;
			} else {
				left = 0;
			}
			var thisHeight = tableDef.tabHeights;
			if (IsArray(thisHeight)) {
				thisHeight = tableDef.tabHeights[row];
			}
			for (var col = 0; col < tableDef.tabAcross; col += 1) {
				var curValue = null;
				// find a template
				if (IsArray(tableDef.tabProtos)) {
					curValue = tableDef.tabProtos[curIndex % tableDef.tabProtos.length];
				} else {
					curValue = tableDef.tabProtos;
				}
				// call the setup method
				if (tableDef.tabSetup) {
					tableDef.tabSetup(curValue, col, row);
				}
				// instantiate the template
				curValue = View({_proto: curValue, _parent: this});
				// set the value
				if (tableDef.tabValueSlot) {
					var slotName = tableDef.tabValueSlot;
					if (IsArray(slotName)) {
						slotName = slotName[curIndex % slotName.length];
					}
					if (IsArray(tableDef.tabValues)) {
						curValue[slotName] = tableDef.tabValues[curIndex % tableDef.tabValues.length];
					} else {
						curValue[slotName] = tableDef.tabValues;
					}
				}
				// set the bounds
				var thisWidth = tableDef.tabWidths;
				if (IsArray(thisWidth)) {
					thisWidth = tableDef.tabWidths[col];
				}
				curValue.viewBounds = RelBounds(left, top, thisWidth, thisHeight);

				retval.push(curValue);
				// next row
				left += thisWidth;
				curIndex += 1;
			}
			top += thisHeight
		}
		return retval;
	},
	LayoutChildrenMatrix : function(tableDef, parentTop, parentLeft) {
		var curIndex = 0;
		var top = parentTop;
		var left = parentLeft;
		for (var row = 0; row < tableDef.tabDown; row+=1) {
			left = parentLeft;
			var thisHeight = tableDef.tabHeights;
			if (IsArray(thisHeight)) {
				thisHeight = tableDef.tabHeights[row];
			}
			for (var col = 0; col < tableDef.tabAcross; col += 1) {
				var thisWidth = tableDef.tabWidths;
				if (IsArray(thisWidth)) {
					thisWidth = tableDef.tabWidths[col];
				}
				var curValue = null;
				// find a template
				curValue = tableDef.tabChildren[curIndex % tableDef.tabChildren.length];
				if (curValue === null) {
					// use for spacing
				} else {
					if (typeof curValue == "string") { // convert strings to a text view
						curValue = View({_proto: protoText, text: curValue});
						// should add an anonymous child view for this
						//this.viewChildren.push(curValue);
					}
					// call the setup method
					if (tableDef.tabSetup) {
						tableDef.tabSetup(curValue, col, row);
					}
					// set the value
					if (tableDef.tabValueSlot) {
						if (IsArray(tableDef.tabValues)) {
							curValue[tableDef.tabValueSlot] = tableDef.tabValues[curIndex % tableDef.tabValues.length];
						} else {
							curValue[tableDef.tabValueSlot] = tableDef.tabValues;
						}
					}
					// set the bounds
					curValue.viewBounds = RelBounds(left, top, thisWidth, thisHeight);
				}
				// now these are real views, and not template, so we've just set them up correctly
				// next row
				left += thisWidth;
				curIndex += 1;
			}
			top += thisHeight
		}
	},
	MoveBehind : function(view) {
		// we only can reorder if same parent
		if (view._parent != this._parent) {
			return;
		}
	},
	SyncChildren : function(view) {
		// reorder the children to match
		var allChildren = this.ChildViewFrames();
		var last = allChildren[allChildren.length-1].viewElement;
		for (var i=allChildren.length-2;i>=0;i-=1) {
			var child = allChidlren[i].viewElement;
			this.viewElement.removeChild(child);
			this.viewElement.insertBefore(child, last);
			last = child;
		}
	},
	SetupIdle : function(milliseconds) {
		if (this.viewTimer && this.viewTimer.timer) {
			clearInterval(this.viewTimer.timer);
		}
		if (milliseconds) {
			var self = this;
			var f = function() { if (self.ViewIdleScript) self.ViewIdleScript(); }
			this.viewTimer = {
				timer : setInterval(f, milliseconds),
				func : f,
				interval : milliseconds
			};
		} else {
			this.viewTimer = null;
		}
	},
	SuspendIdle : function() {
		if (this.currentViewAnimation) {
			this.currentViewAnimation.Finish(); // bring it to an end now
			this.currentViewAnimation = null;
		}
		if (this.viewTimer && this.viewTimer.timer) {
			clearInterval(this.viewTimer.timer);
			this.viewTimer.timer = null;
			return true;
		}
		return false;
	},
	ResumeIdle : function() {
		if (this.viewTimer && !this.viewTimer.timer) {
			this.viewTimer.timer = setInterval(this.viewTimer.func, this.viewTimer.interval);
			this.viewTimer.func() // call it right away
		}
	},
	SetViewAnimation : function(animproto) {
		if (this.currentViewAnimation) {
			this.currentViewAnimation.Finish(); // bring it to an end now
		}
		if (animproto) {
			this.currentViewAnimation = Proto({
				_proto : animproto,
				view : this,
				phase : 0.0
			});
			this.currentViewAnimation.Start();
		} else {
			this.currentViewAnimation = null;
		}
	},
	FilterDialog : function() {
		this.Open();
	},
	AddStepView : function(childViewTemplate) {
		var childView = View({
			_proto : childViewTemplate
		});
		childView._parent = this;
		this.stepChildren.push(childView);
		this.__orderedChildren.push(childView);
		childView.Open();
		return childView;
	},
	RemoveStepView : function(childView) {
		this.stepChildren.removeAll(childView);
		this.__orderedChildren.removeAll(childView);
		childView.Close();
	},
	Hilite : function(onOff) {
		if (onOff) {
			if (this.viewFlags & vSelected) {
				return; // already hilighted
			}
			this.viewFlags |= vSelected;
			this.viewElement.setAttribute('hilite','true');
		} else {
			if (!(this.viewFlags & vSelected)) {
				return; // already off
			}
			this.viewFlags &= ~vSelected;
			if (GetView('viewFrontKey') == this) {
				// make sure to remove this
				SetKeyView(null);
			}
			this.viewElement.removeAttribute('hilite');
		}
		// force the class attribute to be redone to notice the above attribute
		this.viewElement.setAttribute('class',this.viewElement.getAttribute('class'));
		this.ViewHiliteScript(onOff);
	},
	HiliteUnique : function(onOff) {
		this.Hilite(onOff);
		if (onOff) {
			// make sure everything else is off
			var siblings = this._parent.ChildViewFrames();
			for (var i=0;i<siblings.length;i+=1) {
				if (siblings[i] != this) {
					siblings[i].Hilite(false); // turn it off
				}
			}
		}
	},
	GenericTracking : function(unit, isButton) {
		if ((this.viewFlags & vDisabled) === 0) {
			this.Hilite(true);
		}
		var self = this;
		var inside = true;
		var lastClientX = unit.clientX;
		var lastClientY = unit.clientY;
		var trackMouseMoveHandler = function(event) {
			self.ViewDragScript(event, event.clientX - lastClientX, event.clientY - lastClientY);
			lastClientX = event.clientX;
			lastClientY = event.clientY;
			event.stopPropagation();
			event.preventDefault();
		};
		var trackMouseOverHandler = function(event) {
			if ((self.viewFlags & vDisabled) === 0) {
				self.Hilite(true);
				inside = true;
				if (!isButton) {
					self.ButtonPressedScript();
				}
			}
			event.stopPropagation();
			event.preventDefault();
		};
		var trackMouseOutHandler = function(event) {
			if ((self.viewFlags & vDisabled) === 0) {
				self.Hilite(false);
				inside = false;
			}
			event.stopPropagation();
			event.preventDefault();
		};
		var trackMouseUpHandler = function(event) {
			// remove the handlers we added
			document.removeEventListener('mousemove', trackMouseMoveHandler, true);
			document.removeEventListener('mouseup', trackMouseUpHandler, true);
			self.viewElement.removeEventListener('mouseover', trackMouseOverHandler, true);
			self.viewElement.removeEventListener('mouseout', trackMouseOutHandler, true);
			if ((self.viewFlags & vDisabled) === 0) {
				if (inside) {
					self.Hilite(false);
					if (isButton) {
						self.ButtonClickScript();
					} else if (self.viewFlags & vKeyable) {
						SetKeyView(self); // change key view to this
					}
				}
			}
			event.stopPropagation();
			event.preventDefault();
			self.ResumeIdle();
		};
		document.addEventListener('mousemove', trackMouseMoveHandler, true);
		document.addEventListener('mouseup', trackMouseUpHandler, true);
		this.viewElement.addEventListener('mouseover', trackMouseOverHandler, true);
		this.viewElement.addEventListener('mouseout', trackMouseOutHandler, true);
		// make sure to call ButtonPressedScript at least once
		if (!isButton && (this.viewFlags & vDisabled) === 0) {
			this.ButtonPressedScript();
		}
		this.SuspendIdle(); // don't idle while traccking - ugly!!!
		return true;
	},
	TrackHilite : function(unit) {
		return this.GenericTracking(unit, false);
	},
	TrackButton : function(unit) {
		return this.GenericTracking(unit, true);
	},
	Drag : function(unit, dragBounds) {
		var startX = unit.x;
		var startY = unit.y;
		var curX = this.viewElement.offsetLeft;
		var curY = this.viewElement.offsetTop;
		var self = this;
		function trackMouseMoveHandler(event) {
			var deltaX = event.x - startX;
			var deltaY = event.y - startY;
			var newX = curX + deltaX;
			var newY = curY + deltaY;
			// limit into rect, adjusting newX, newY as we go
			var gb = self.GlobalBox();
			gb.left += deltaX; gb.right += deltaX;
			gb.top += deltaY; gb.bottom += deltaY;
			if (gb.left < dragBounds.left) {
				newX += dragBounds.left - gb.left;
			} else if (gb.right > dragBounds.right) {
				newX -= gb.right - dragBounds.right;
			}
			if (gb.top < dragBounds.top) {
				newY += dragBounds.top - gb.top;
			} else if (gb.bottom > dragBounds.bottom) {
				newY -= gb.bottom - dragBounds.bottom;
			}
			self.OffsetView(newX - curX, newY - curY); // and offset by this delta
			startX = event.x + newX - (curX + deltaX);
			startY = event.y + newY - (curY + deltaY);
			if (self.ViewDraggedScript) {
				self.ViewDraggedScript(newX, newY);
			}
		}
		function trackMouseUpHandler(event) {
			document.removeEventListener("mousemove", trackMouseMoveHandler, true);
			document.removeEventListener("mouseup", trackMouseUpHandler, true);
			if (self.ViewDragDoneScript) {
				self.ViewDragDoneScript();
			}
		}
		document.addEventListener("mousemove", trackMouseMoveHandler, true);
		document.addEventListener("mouseup", trackMouseUpHandler, true);
	},
	Dirty : function() {
		// by default, views automatically draw themselves once their underlying viewElement is changed
		// so no need to redraw
	},
	ReorientToScreen : function() {
		// default to calling the children
		this.SyncView();
		for (var i=0;i<this.__orderedChildren.length;i+=1) {
			this.__orderedChildren[i].ReorientToScreen();
		}
	},
	SyncView : function() {
		if (this.viewBounds) {
			this.CalcJustify();
		}
		this.ViewSetupFormScript();
		//this.Dirty();
	}
});


function View(obj)
{
	var ctor = function(fields) {
		if (fields._mixins) {
			wtAddMixins(this, fields._mixins); // add these before we override the things
		}
		for (var i in fields) {
			if (i != '_mixins') { // already set up the mixin field
				this[i] = fields[i];
			}
		}
		if (this.viewElementId) {
			// got a view ID, add to view heirarchy
			this.children = {};
			if (this._parent) {
				this._parent.children[this.viewElementId] = this;
			} else {
				wt_Private.wt_TopLevelObjects[this.viewElementId] = this;
			}
		}
		this.notifications = new Array();
	}
	if (obj._proto) {
		ctor.prototype = obj._proto;
	} else {
		// make sure that root has parent heirarchy
		ctor.prototype = protoView; //new ViewObject();
	}
	var retval = new ctor(obj);
	// we can now init it - but we only init the one specific thing (and don't do inheritence)
	// This is wrong, because the the sub is something - so we provide two inits
	if (obj.__init) {
		retval.__init();
	}
	if (retval._init) {
		retval._init();
	}
	return retval;
}


// The "core" creation classes
protoImage = View({
	_proto : protoView,
	elementClass : "img",
	viewClass : "image",
	imageSrc : null,
	ViewSetupChildrenScript : function() {
		protoView.ViewSetupChildrenScript.call(this);
		if (!this.viewElement.src) {
			this.viewElement.src = this.imageSrc;
		}
	}
});

protoText = View({
	_proto : protoView,
	viewClass : "text",
	text : '',
	chromeStyle : 'systemFont',
	ViewSetupChildrenScript : function() {
		protoView.ViewSetupChildrenScript.call(this);
		this.viewElement.innerText = this.text;
	},
	ViewChangedScript : function(slot, value) {
		if (slot == 'text') {
			this.viewElement.innerText = this.text;
		}
	}
});

protoHTMLText = View({
	_proto : protoView,
	viewClass : "htmlText",
	text : '',
	ViewSetupChildrenScript : function() {
		protoView.ViewSetupChildrenScript.call(this);
		this.viewElement.innerHTML = this.text;
	},
	ViewChangedScript : function(slot, value) {
		if (slot == 'text') {
			this.viewElement.innerHTML = this.text;
		}
	}
});

